import 'package:bloc_stream/bloc_stream.dart';
import 'package:test/test.dart';

class CounterActions {
  static BlocStreamAction<int> increment = (input, _bloc) async* {
    yield input + 1;
  };
  static BlocStreamAction<int> decrement = (input, _bloc) async* {
    yield input - 1;
  };
}

class CounterBloc extends BlocStream<int> {
  @override
  int get initialValue => 0;
}

void main() {
  group('CounterBloc', () {
    test('increments and decrements correctly', () {
      final counter = CounterBloc();
      assert(counter.value == 0);
      counter.add(CounterActions.increment);
      assert(counter.value == 1);
      counter.add(CounterActions.decrement);
      assert(counter.value == 0);
    });
  });
}
